package com.jasamedika.medifirst2000.controller;

import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.NotaDinasService;
import com.jasamedika.medifirst2000.vo.NotaDinasVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

@RestController
@RequestMapping("/nota-dinas")
public class NotaDinasController extends LocaleController<NotaDinasVO> {

	private static final Logger LOGGER = getLogger(NotaDinasController.class);

	@Autowired
	private NotaDinasService notaDinasService;

	@RequestMapping(value = "/save-nota-dinas/", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> addVO(@Valid @RequestBody NotaDinasVO vo, HttpServletRequest request) {
		try {
			Map<String, Object> result = notaDinasService.addNotaDinas(vo);
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when addNotaDinas", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when addNotaDinas", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/get-no-surat/", method = GET)
	public ResponseEntity<Map<String, Object>> getNoSurat(HttpServletRequest request) {
		try {
			String noSurat = notaDinasService.getNoSurat();
			Map<String, Object> result = new HashMap<>();
			result.put("noSurat", noSurat);
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when getNoSurat", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when getNoSurat", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/get-inbox-nota-dinas", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<List<Map<String, Object>>> getInboxNotaDinas(
			@RequestParam(value = "flag", required = false) String flag,
			@RequestParam(value = "dateStart", required = false) String dateStart,
			@RequestParam(value = "dateEnd", required = false) String dateEnd,
			@RequestParam(value = "idRuangan", required = false) Integer idRuangan,
			@RequestParam(value = "idPegawai", required = false) Integer idPegawai) {
		try {
			List<Map<String, Object>> notaDinas = notaDinasService.getInboxNotaDinas(dateStart, dateEnd, idRuangan,
					flag, idPegawai);
			return getJsonResponse(notaDinas, OK, mapHeaderMessage);
		} catch (IllegalArgumentException e) {
			throw new ServiceVOException(e.getMessage());
		}
	}

	@RequestMapping(value = "/get-outbox-nota-dinas", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<List<Map<String, Object>>> getOutboxNotaDinas(
			@RequestParam(value = "flag", required = false) String flag,
			@RequestParam(value = "dateStart", required = false) String dateStart,
			@RequestParam(value = "dateEnd", required = false) String dateEnd,
			@RequestParam(value = "idRuangan", required = false) Integer idRuangan,
			@RequestParam(value = "idPegawai", required = false) Integer idPegawai) {
		try {
			List<Map<String, Object>> notaDinas = notaDinasService.getOutboxNotaDinas(dateStart, dateEnd, idRuangan,
					flag, idPegawai);
			return getJsonResponse(notaDinas, HttpStatus.OK, mapHeaderMessage);
		} catch (IllegalArgumentException e) {
			throw new ServiceVOException(e.getMessage());
		}
	}

}
